------------------
--Global Variables
------------------
LMB_LEVEL_TABLE = {};
LMB_MAX_LEVEL = 70;
LMB_TEXT_STYLE = 2;
LMB_XP_STRING	= "you gain (.+) experience."

LMB_kills    = 0
LMB_gainedXP = 0
LMB_avgXP    = 0
LMB_toLevel  = 0
LMB_XPToMax  = 0
LMB_maxXP    = 0

---------
--On Load
---------
function LevelMaxBar_OnLoad()
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("UPDATE_EXHAUSTION");
   this:RegisterEvent("PLAYER_ENTERING_WORLD");
   this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
end

---------------
--Event Handler
---------------
function LevelMaxBar_OnEvent (event)
	if (event == "PLAYER_XP_UPDATE" or event == "PLAYER_LEVEL_UP" or event == "PLAYER_ENTERING_WORLD") then
		LMB_currentXP = UnitXP("player");
		LMB_playerLevel = UnitLevel("player");

		if (LMB_playerLevel == LMB_MAX_LEVEL) then
			Congratulations();
		else
			CalculateLMB_XPToMax();
		end
   elseif (event == "CHAT_MSG_COMBAT_XP_GAIN") then
		LMB_kills = LMB_kills + 1	
		for xpGain in string.gmatch(arg1, LMB_XP_STRING) do
			LMB_gainedXP = LMB_gainedXP + xpGain;
		end

		LMB_avgXP = math.ceil(LMB_gainedXP / LMB_kills);
		LMB_toLevel = math.ceil(LMB_XPToMax / LMB_avgXP);
	end

end

-------------------------
--Dirty rounding function
-------------------------
function RoundToNearest(decimalValue)
	local integerValue = 0;

	if (math.fmod(decimalValue,1) >= 0.5) then
		integerValue = math.ceil(decimalValue);
	else
		integerValue = math.floor(decimalValue);
	end

	return integerValue;
end

----------------------------------
--Initial function called from XML
--Handles slash command
----------------------------------
function LevelMaxBar_initialize()
	LevelMaxBarFrame:Show();

   for i=1, 28 do
      LMB_LEVEL_TABLE[i] = ((40*(i^2)) + (360 * i));
   end
   LMB_LEVEL_TABLE[29] = 44300;
   LMB_LEVEL_TABLE[30] = 47400;
   LMB_LEVEL_TABLE[31] = 50800;
   for i=32, 59 do
      LMB_LEVEL_TABLE[i] = ((65 * (i^2)) - (165 * i) - 6750);
   end
   LMB_LEVEL_TABLE[60] = 494000;
   for i=61, 69 do
      mxp = 235 + (5 * i);
      LMB_LEVEL_TABLE[i] = 155 + mxp * (1344 - ((69-i)*(7+(69-i)*8-1)/2))
   end      
	maxXP = 0;

	for i=1, (LMB_MAX_LEVEL - 1) do
	   LMB_LEVEL_TABLE[i] = (RoundToNearest(LMB_LEVEL_TABLE[i]/100)*100);
		LMB_maxXP = LMB_maxXP + LMB_LEVEL_TABLE[i];
--		DEFAULT_CHAT_FRAME:AddMessage("LMB debug: lvl "..i..", "..LMB_LEVEL_TABLE[i]..".");
	end

	LevelMaxBarFrameStatusBar:SetMinMaxValues(0, LMB_maxXP);

	SlashCmdList["LEVELMAXBAR"] = LMBhandler;
	SLASH_LEVELMAXBAR1 = "/lmb";
	SLASH_LEVELMAXBAR2 = "/levelmaxbar";
	SLASH_LEVELMAXBAR3 = "/LevelMaxBar";

end

----------------
--Slash commands
----------------

function LMBhandler(message)
	if(message) then
		local msg = string.lower(message);
		if(msg == "on") then
			LevelMaxBarFrame:Show();
		elseif (msg == "off") then
			LevelMaxBarFrame:Hide();
		elseif (msg == "calc") then
			CalculateLMB_XPToMax2();
		elseif (msg == "style") then
			if (LMB_TEXT_STYLE == 1) then
				LMB_TEXT_STYLE = 2;
			else
				LMB_TEXT_STYLE = 1;
			end
			CalculateLMB_XPToMax();
		else
			DEFAULT_CHAT_FRAME:AddMessage("/lmb on - Display level max bar");
			DEFAULT_CHAT_FRAME:AddMessage("/lmb off - Hide level max bar");
			DEFAULT_CHAT_FRAME:AddMessage("/lmb style - Switch text style on bar");
			DEFAULT_CHAT_FRAME:AddMessage("/lmb help - Show help text");
			DEFAULT_CHAT_FRAME:AddMessage("/lmb calc - Calculate kills to max level");
		end
	end
end

-------------------
--Max level message
-------------------

function Congratulations()
	LevelMaxBarFrame:Hide();
	DEFAULT_CHAT_FRAME:AddMessage("You are level "..LMB_MAX_LEVEL.."!  Congratulations!");
	DEFAULT_CHAT_FRAME:AddMessage("Turning off level max bar!");
end

---------
--Display
---------

function CalculateLMB_XPToMax()
	local LMB_totalXP = 0;
	local LMB_XPToMaxPercentage = 0;

	for i=1, (LMB_playerLevel - 1) do
		LMB_totalXP = LMB_totalXP + LMB_LEVEL_TABLE[i];
	end

	LMB_totalXP = LMB_totalXP + LMB_currentXP;
	LMB_XPToMax = LMB_maxXP - LMB_totalXP;
	LMB_XPToMaxPercentage = RoundToNearest((LMB_totalXP / LMB_maxXP) * 100);

	LevelMaxBarFrameStatusBar:SetValue(LMB_totalXP);
   DEFAULT_CHAT_FRAME:AddMessage(LMB_XPToMax.." exp until lvl "..LMB_MAX_LEVEL.." ("..LMB_XPToMaxPercentage.."%)",0.435,0.435,1.0);
	
	if (LMB_TEXT_STYLE == 1) then
		LevelMaxBarText:SetText(LMB_totalXP.."/"..LMB_maxXP.." ("..LMB_XPToMaxPercentage.."%)");
	elseif (LMB_TEXT_STYLE == 2) then
		LevelMaxBarText:SetText(LMB_XPToMax.." exp until lvl "..LMB_MAX_LEVEL);
	end
end

function CalculateLMB_XPToMax2()
        DEFAULT_CHAT_FRAME:AddMessage(LMB_toLevel.." kills until level "..LMB_MAX_LEVEL.." (averaging "..LMB_avgXP.." / kill)");
end
